Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/EsGriewankSampleTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/EsGriewankSampleTest.cs	(revision 11466)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/EsGriewankSampleTest.cs	(revision 11514)
@@ -29,16 +29,7 @@
 
 namespace HeuristicLab.Tests {
-  /// <summary>
-  /// Summary description for EsGriewankSampleTest
-  /// </summary>
   [TestClass]
   public class EsGriewankSampleTest {
-    private const string samplesDirectory = SamplesUtils.Directory;
-
-    [ClassInitialize]
-    public static void MyClassInitialize(TestContext testContext) {
-      if (!Directory.Exists(samplesDirectory))
-        Directory.CreateDirectory(samplesDirectory);
-    }
+    private const string SampleFileName = "ES_Griewank";
 
     [TestMethod]
@@ -47,5 +38,6 @@
     public void CreateEsGriewankSampleTest() {
       var es = CreateEsGriewankSample();
-      XmlGenerator.Serialize(es, @"Samples\ES_Griewank.hl");
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
+      XmlGenerator.Serialize(es, path);
     }
 
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GATspSampleTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GATspSampleTest.cs	(revision 11466)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GATspSampleTest.cs	(revision 11514)
@@ -33,11 +33,5 @@
   [TestClass]
   public class GATspSampleTest {
-    private const string samplesDirectory = SamplesUtils.Directory;
-    [ClassInitialize]
-    public static void MyClassInitialize(TestContext testContext) {
-      if (!Directory.Exists(samplesDirectory))
-        Directory.CreateDirectory(samplesDirectory);
-    }
-
+    private const string SampleFileName = "GA_TSP";
 
     [TestMethod]
@@ -46,6 +40,8 @@
     public void CreateGaTspSampleTest() {
       var ga = CreateGaTspSample();
-      XmlGenerator.Serialize(ga, @"Samples\GA_TSP.hl");
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
+      XmlGenerator.Serialize(ga, path);
     }
+
     [TestMethod]
     [TestCategory("Samples.Execute")]
@@ -63,4 +59,5 @@
     private GeneticAlgorithm CreateGaTspSample() {
       GeneticAlgorithm ga = new GeneticAlgorithm();
+
       #region Problem Configuration
       var provider = new TSPLIBTSPInstanceProvider();
@@ -77,4 +74,5 @@
         ga, 100, 1, 1000, 0.05);
       #endregion
+
       return ga;
     }
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GAVrpSampleTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GAVrpSampleTest.cs	(revision 11466)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GAVrpSampleTest.cs	(revision 11514)
@@ -34,16 +34,7 @@
 
 namespace HeuristicLab.Tests {
-  /// <summary>
-  /// Summary description for GAVrpSampleTest
-  /// </summary>
   [TestClass]
   public class GAVrpSampleTest {
-    private const string samplesDirectory = SamplesUtils.Directory;
-    [ClassInitialize]
-    public static void MyClassInitialize(TestContext testContext) {
-      if (!Directory.Exists(samplesDirectory))
-        Directory.CreateDirectory(samplesDirectory);
-    }
-
+    private const string SampleFileName = "GA_VRP";
 
     [TestMethod]
@@ -52,5 +43,6 @@
     public void CreateGaVrpSampleTest() {
       var ga = CreateGaVrpSample();
-      XmlGenerator.Serialize(ga, @"Samples\GA_VRP.hl");
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
+      XmlGenerator.Serialize(ga, path);
     }
 
@@ -70,4 +62,5 @@
     private GeneticAlgorithm CreateGaVrpSample() {
       GeneticAlgorithm ga = new GeneticAlgorithm();
+
       #region Problem Configuration
       VehicleRoutingProblem vrpProblem = new VehicleRoutingProblem();
@@ -117,4 +110,5 @@
         .Single(), true);
       #endregion
+
       return ga;
     }
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPArtificialAntSampleTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPArtificialAntSampleTest.cs	(revision 11466)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPArtificialAntSampleTest.cs	(revision 11514)
@@ -30,15 +30,7 @@
 
 namespace HeuristicLab.Tests {
-  /// <summary>
-  /// Summary description for GPArtificialAntSampleTest
-  /// </summary>
   [TestClass]
   public class GPArtificialAntSampleTest {
-    private const string samplesDirectory = SamplesUtils.Directory;
-    [ClassInitialize]
-    public static void MyClassInitialize(TestContext testContext) {
-      if (!Directory.Exists(samplesDirectory))
-        Directory.CreateDirectory(samplesDirectory);
-    }
+    private const string SampleFileName = "SGP_SantaFe";
 
     [TestMethod]
@@ -47,5 +39,6 @@
     public void CreateGpArtificialAntSampleTest() {
       var ga = CreateGpArtificialAntSample();
-      XmlGenerator.Serialize(ga, @"Samples\SGP_SantaFe.hl");
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
+      XmlGenerator.Serialize(ga, path);
     }
 
@@ -65,4 +58,5 @@
     public GeneticAlgorithm CreateGpArtificialAntSample() {
       GeneticAlgorithm ga = new GeneticAlgorithm();
+
       #region Problem Configuration
       ArtificialAntProblem antProblem = new ArtificialAntProblem();
@@ -94,4 +88,5 @@
         .Single(), false);
       #endregion
+
       return ga;
     }
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPLawnMowerSampleTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPLawnMowerSampleTest.cs	(revision 11466)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPLawnMowerSampleTest.cs	(revision 11514)
@@ -20,5 +20,4 @@
 #endregion
 
-using System.IO;
 using System.Linq;
 using HeuristicLab.Algorithms.GeneticAlgorithm;
@@ -28,16 +27,6 @@
 
 namespace HeuristicLab.Tests {
-  /// <summary>
-  /// Summary description for GPLawnMowerSampleTest
-  /// </summary>
   [TestClass]
   public class GPLawnMowerSampleTest {
-    private const string samplesDirectory = SamplesUtils.Directory;
-    [ClassInitialize]
-    public static void MyClassInitialize(TestContext testContext) {
-      if (!Directory.Exists(samplesDirectory))
-        Directory.CreateDirectory(samplesDirectory);
-    }
-
     [TestMethod]
     [TestCategory("Samples.Execute")]
@@ -57,5 +46,4 @@
 
       #endregion
-
       #region Algorithm Configuration
 
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPMultiplexerSampleTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPMultiplexerSampleTest.cs	(revision 11466)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPMultiplexerSampleTest.cs	(revision 11514)
@@ -33,10 +33,5 @@
   [TestClass]
   public class GPMultiplexerSampleTest {
-    private const string samplesDirectory = SamplesUtils.Directory;
-    [ClassInitialize]
-    public static void MyClassInitialize(TestContext testContext) {
-      if (!Directory.Exists(samplesDirectory))
-        Directory.CreateDirectory(samplesDirectory);
-    }
+    private const string SampleFileName = "GP_Multiplexer";
 
     [TestMethod]
@@ -45,5 +40,5 @@
     public void CreateGpMultiplexerSampleTest() {
       var ga = CreateGpMultiplexerSample();
-      var path = Path.Combine(samplesDirectory, "GP_Multiplexer.hl");
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
       XmlGenerator.Serialize(ga, path);
     }
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPSymbolicClassificationSampleTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPSymbolicClassificationSampleTest.cs	(revision 11466)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPSymbolicClassificationSampleTest.cs	(revision 11514)
@@ -33,15 +33,7 @@
 
 namespace HeuristicLab.Tests {
-  /// <summary>
-  /// Summary description for GPSymbolicClassificationSampleTest
-  /// </summary>
   [TestClass]
   public class GPSymbolicClassificationSampleTest {
-    private const string samplesDirectory = SamplesUtils.Directory;
-    [ClassInitialize]
-    public static void MyClassInitialize(TestContext testContext) {
-      if (!Directory.Exists(samplesDirectory))
-        Directory.CreateDirectory(samplesDirectory);
-    }
+    private const string SampleFileName = "SGP_SymbClass";
 
     [TestMethod]
@@ -50,5 +42,6 @@
     public void CreateGpSymbolicClassificationSampleTest() {
       var ga = CreateGpSymbolicClassificationSample();
-      XmlGenerator.Serialize(ga, @"Samples\SGP_SymbClass.hl");
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
+      XmlGenerator.Serialize(ga, path);
     }
 
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPSymbolicRegressionSampleTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPSymbolicRegressionSampleTest.cs	(revision 11466)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPSymbolicRegressionSampleTest.cs	(revision 11514)
@@ -33,16 +33,7 @@
 
 namespace HeuristicLab.Tests {
-  /// <summary>
-  /// Summary description for GPSymbolicRegressionSampleTest
-  /// </summary>
   [TestClass]
   public class GPSymbolicRegressionSampleTest {
-    private const string samplesDirectory = SamplesUtils.Directory;
-    [ClassInitialize]
-    public static void MyClassInitialize(TestContext testContext) {
-      if (!Directory.Exists(samplesDirectory))
-        Directory.CreateDirectory(samplesDirectory);
-    }
-
+    private const string SampleFileName = "SGP_SymbReg";
 
     [TestMethod]
@@ -51,5 +42,6 @@
     public void CreateGpSymbolicRegressionSampleTest() {
       var ga = CreateGpSymbolicRegressionSample();
-      XmlGenerator.Serialize(ga, @"Samples\SGP_SymbReg.hl");
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
+      XmlGenerator.Serialize(ga, path);
     }
     [TestMethod]
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPTimeSeriesSampleTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPTimeSeriesSampleTest.cs	(revision 11466)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPTimeSeriesSampleTest.cs	(revision 11514)
@@ -32,10 +32,5 @@
   [TestClass]
   public class GPTimeSeriesSampleTest {
-    private const string samplesDirectory = SamplesUtils.Directory;
-    [ClassInitialize]
-    public static void MyClassInitialize(TestContext testContext) {
-      if (!Directory.Exists(samplesDirectory))
-        Directory.CreateDirectory(samplesDirectory);
-    }
+    private const string SampleFileName = "OSGP_TimeSeries";
 
     [TestMethod]
@@ -44,5 +39,5 @@
     public void CreateGpTimeSeriesSampleTest() {
       var ga = CreateGpTimeSeriesSample();
-      var path = Path.Combine(samplesDirectory, "OSGP_TimeSeries.hl");
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
       XmlGenerator.Serialize(ga, path);
     }
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GaussianProcessRegressionSampleTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GaussianProcessRegressionSampleTest.cs	(revision 11466)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GaussianProcessRegressionSampleTest.cs	(revision 11514)
@@ -29,15 +29,7 @@
 
 namespace HeuristicLab.Tests {
-  /// <summary>
-  /// Summary description for GaussianProcessRegressionSampleTest
-  /// </summary>
   [TestClass]
   public class GaussianProcessRegressionSampleTest {
-    private const string samplesDirectory = SamplesUtils.Directory;
-    [ClassInitialize]
-    public static void MyClassInitialize(TestContext testContext) {
-      if (!Directory.Exists(samplesDirectory))
-        Directory.CreateDirectory(samplesDirectory);
-    }
+    private const string SampleFileName = "GPR";
 
     [TestMethod]
@@ -46,6 +38,8 @@
     public void CreateGaussianProcessRegressionSampleTest() {
       var gpr = CreateGaussianProcessRegressionSample();
-      XmlGenerator.Serialize(gpr, @"Samples\GPR.hl");
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
+      XmlGenerator.Serialize(gpr, path);
     }
+
     [TestMethod]
     [TestCategory("Samples.Execute")]
@@ -66,4 +60,5 @@
       var regProblem = new RegressionProblem();
       regProblem.Load(provider.LoadData(instance));
+
       #region Algorithm Configuration
       gpr.Name = "Gaussian Process Regression";
@@ -77,4 +72,5 @@
       gpr.SetSeedRandomly = true;
       #endregion
+
       gpr.Engine = new ParallelEngine.ParallelEngine();
       return gpr;
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GeSymbolicRegressionSampleTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GeSymbolicRegressionSampleTest.cs	(revision 11466)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GeSymbolicRegressionSampleTest.cs	(revision 11514)
@@ -30,17 +30,9 @@
 
 namespace HeuristicLab.Tests {
-  /// <summary>
-  /// Summary description for GeSymbolicRegressionSampleTest
-  /// </summary>
   [TestClass]
   public class GeSymbolicRegressionSampleTest {
-    private const string samplesDirectory = SamplesUtils.Directory;
-    [ClassInitialize]
-    public static void MyClassInitialize(TestContext testContext) {
-      if (!Directory.Exists(samplesDirectory))
-        Directory.CreateDirectory(samplesDirectory);
-    }
+    #region artificial ant
+    private const string GeArtificialAntSampleFileName = "GE_ArtificialAnt";
 
-    #region artificial ant
     [TestMethod]
     [TestCategory("Samples.Create")]
@@ -48,5 +40,6 @@
     public void CreateGeArtificialAntSampleTest() {
       var geaa = CreateGeArtificialAntSample();
-      XmlGenerator.Serialize(geaa, @"Samples\GE_ArtificialAnt.hl");
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, GeArtificialAntSampleFileName + SamplesUtils.SampleFileExtension);
+      XmlGenerator.Serialize(geaa, path);
     }
 
@@ -62,4 +55,5 @@
     public OffspringSelectionGeneticAlgorithm CreateGeArtificialAntSample() {
       OffspringSelectionGeneticAlgorithm ga = new OffspringSelectionGeneticAlgorithm();
+
       #region Problem Configuration
       var problem = new HeuristicLab.Problems.GrammaticalEvolution.GEArtificialAntProblem();
@@ -72,4 +66,5 @@
         ga, 200, 1, 50, 0.05, 200);
       #endregion
+
       return ga;
     }
@@ -77,5 +72,6 @@
 
     #region symbolic regression
-    #endregion
+    private const string GeSymbolicRegressionSampleFileName = "GE_SymbReg";
+
     [TestMethod]
     [TestCategory("Samples.Create")]
@@ -83,5 +79,6 @@
     public void CreateGeSymbolicRegressionSampleTest() {
       var geSymbReg = CreateGeSymbolicRegressionSample();
-      XmlGenerator.Serialize(geSymbReg, @"Samples\GE_SymbReg.hl");
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, GeSymbolicRegressionSampleFileName + SamplesUtils.SampleFileExtension);
+      XmlGenerator.Serialize(geSymbReg, path);
     }
 
@@ -97,4 +94,5 @@
     public OffspringSelectionGeneticAlgorithm CreateGeSymbolicRegressionSample() {
       var ga = new OffspringSelectionGeneticAlgorithm();
+
       #region Problem Configuration
       var problem = new HeuristicLab.Problems.GrammaticalEvolution.GESymbolicRegressionSingleObjectiveProblem();
@@ -116,6 +114,8 @@
         ga, 1000, 1, 50, 0.05, 200);
       #endregion
+
       return ga;
     }
+    #endregion
   }
 }
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/IslandGaTspSampleTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/IslandGaTspSampleTest.cs	(revision 11466)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/IslandGaTspSampleTest.cs	(revision 11514)
@@ -34,10 +34,5 @@
   [TestClass]
   public class UnitTest1 {
-    private const string samplesDirectory = SamplesUtils.Directory;
-    [ClassInitialize]
-    public static void MyClassInitialize(TestContext testContext) {
-      if (!Directory.Exists(samplesDirectory))
-        Directory.CreateDirectory(samplesDirectory);
-    }
+    private const string SampleFileName = "IslandGA_TSP";
 
     [TestMethod]
@@ -46,5 +41,6 @@
     public void CreateIslandGaTspSampleTest() {
       var ga = CreateIslandGaTspSample();
-      XmlGenerator.Serialize(ga, @"Samples\IslandGA_TSP.hl");
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
+      XmlGenerator.Serialize(ga, path);
     }
     [TestMethod]
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/LocalSearchKnapsackSampleTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/LocalSearchKnapsackSampleTest.cs	(revision 11466)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/LocalSearchKnapsackSampleTest.cs	(revision 11514)
@@ -30,15 +30,7 @@
 
 namespace HeuristicLab.Tests {
-  /// <summary>
-  /// Summary description for LocalSearchKnapsackSampleTest
-  /// </summary>
   [TestClass]
   public class LocalSearchKnapsackSampleTest {
-    private const string samplesDirectory = SamplesUtils.Directory;
-    [ClassInitialize]
-    public static void MyClassInitialize(TestContext testContext) {
-      if (!Directory.Exists(samplesDirectory))
-        Directory.CreateDirectory(samplesDirectory);
-    }
+    private const string SampleFileName = "LS_Knapsack";
 
     [TestMethod]
@@ -47,5 +39,6 @@
     public void CreateLocalSearchKnapsackSampleTest() {
       var ls = CreateLocalSearchKnapsackSample();
-      XmlGenerator.Serialize(ls, @"Samples\LS_Knapsack.hl");
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
+      XmlGenerator.Serialize(ls, path);
     }
     [TestMethod]
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/PsoSchwefelSampleTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/PsoSchwefelSampleTest.cs	(revision 11466)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/PsoSchwefelSampleTest.cs	(revision 11514)
@@ -32,15 +32,7 @@
 
 namespace HeuristicLab.Tests {
-  /// <summary>
-  /// Summary description for PsoSchwefelSampleTest
-  /// </summary>
   [TestClass]
   public class PsoSchwefelSampleTest {
-    private const string samplesDirectory = SamplesUtils.Directory;
-    [ClassInitialize]
-    public static void MyClassInitialize(TestContext testContext) {
-      if (!Directory.Exists(samplesDirectory))
-        Directory.CreateDirectory(samplesDirectory);
-    }
+    private const string SampleFileName = "PSO_Schwefel";
 
     [TestMethod]
@@ -49,5 +41,6 @@
     public void CreatePsoSchwefelSampleTest() {
       var pso = CreatePsoSchwefelSample();
-      XmlGenerator.Serialize(pso, @"Samples\PSO_Schwefel.hl");
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
+      XmlGenerator.Serialize(pso, path);
     }
     [TestMethod]
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/RAPGASchedulingSampleTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/RAPGASchedulingSampleTest.cs	(revision 11466)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/RAPGASchedulingSampleTest.cs	(revision 11514)
@@ -29,15 +29,7 @@
 
 namespace HeuristicLab.Tests {
-  /// <summary>
-  /// Summary description for RAPGASchedulingSampleTest
-  /// </summary>
   [TestClass]
   public class RAPGASchedulingSampleTest {
-    private const string samplesDirectory = SamplesUtils.Directory;
-    [ClassInitialize]
-    public static void MyClassInitialize(TestContext testContext) {
-      if (!Directory.Exists(samplesDirectory))
-        Directory.CreateDirectory(samplesDirectory);
-    }
+    private const string SampleFileName = "RAPGA_JSSP";
 
     [TestMethod]
@@ -46,5 +38,6 @@
     public void CreateRAPGASchedulingSampleTest() {
       var ss = CreateRAPGASchedulingSample();
-      XmlGenerator.Serialize(ss, @"Samples\RAPGA_JSSP.hl");
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
+      XmlGenerator.Serialize(ss, path);
     }
 
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/SamplesUtils.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/SamplesUtils.cs	(revision 11466)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/SamplesUtils.cs	(revision 11514)
@@ -12,5 +12,6 @@
 namespace HeuristicLab.Tests {
   public static class SamplesUtils {
-    public const string Directory = @"Samples\";
+    public const string SamplesDirectory = @"Samples\";
+    public const string SampleFileExtension = ".hl";
 
     public static void RunAlgorithm(IAlgorithm a) {
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/ScatterSearchVRPSampleTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/ScatterSearchVRPSampleTest.cs	(revision 11466)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/ScatterSearchVRPSampleTest.cs	(revision 11514)
@@ -29,15 +29,7 @@
 
 namespace HeuristicLab.Tests {
-  /// <summary>
-  /// Summary description for ScatterSearchVRPSampleTest
-  /// </summary>
   [TestClass]
   public class ScatterSearchVRPSampleTest {
-    private const string samplesDirectory = SamplesUtils.Directory;
-    [ClassInitialize]
-    public static void MyClassInitialize(TestContext testContext) {
-      if (!Directory.Exists(samplesDirectory))
-        Directory.CreateDirectory(samplesDirectory);
-    }
+    private const string SampleFileName = "SS_VRP";
 
     [TestMethod]
@@ -46,5 +38,6 @@
     public void CreateScatterSearchVRPSampleTest() {
       var ss = CreateScatterSearchVRPSample();
-      XmlGenerator.Serialize(ss, @"Samples\SS_VRP.hl");
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
+      XmlGenerator.Serialize(ss, path);
     }
 
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/SimulatedAnnealingRastriginSampleTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/SimulatedAnnealingRastriginSampleTest.cs	(revision 11466)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/SimulatedAnnealingRastriginSampleTest.cs	(revision 11514)
@@ -31,15 +31,7 @@
 
 namespace HeuristicLab.Tests {
-  /// <summary>
-  /// Summary description for SimulatedAnnealingRastriginSampleTest
-  /// </summary>
   [TestClass]
   public class SimulatedAnnealingRastriginSampleTest {
-    private const string samplesDirectory = SamplesUtils.Directory;
-    [ClassInitialize]
-    public static void MyClassInitialize(TestContext testContext) {
-      if (!Directory.Exists(samplesDirectory))
-        Directory.CreateDirectory(samplesDirectory);
-    }
+    private const string SampleFileName = "SA_Rastrigin";
 
     [TestMethod]
@@ -48,5 +40,6 @@
     public void CreateSimulatedAnnealingRastriginSampleTest() {
       var sa = CreateSimulatedAnnealingRastriginSample();
-      XmlGenerator.Serialize(sa, @"Samples\SA_Rastrigin.hl");
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
+      XmlGenerator.Serialize(sa, path);
     }
     [TestMethod]
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/TabuSearchTspSampleTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/TabuSearchTspSampleTest.cs	(revision 11466)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/TabuSearchTspSampleTest.cs	(revision 11514)
@@ -30,16 +30,7 @@
 
 namespace HeuristicLab.Tests {
-  /// <summary>
-  /// Summary description for TabuSearchTspSampleTest
-  /// </summary>
   [TestClass]
   public class TabuSearchTspSampleTest {
-    private const string samplesDirectory = SamplesUtils.Directory;
-    [ClassInitialize]
-    public static void MyClassInitialize(TestContext testContext) {
-      if (!Directory.Exists(samplesDirectory))
-        Directory.CreateDirectory(samplesDirectory);
-    }
-
+    private const string SampleFileName = "TS_TSP";
 
     [TestMethod]
@@ -48,5 +39,6 @@
     public void CreateTabuSearchTspSampleTest() {
       var ts = CreateTabuSearchTspSample();
-      XmlGenerator.Serialize(ts, @"Samples\TS_TSP.hl");
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
+      XmlGenerator.Serialize(ts, path);
     }
     [TestMethod]
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/TabuSearchVRPSampleTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/TabuSearchVRPSampleTest.cs	(revision 11466)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/TabuSearchVRPSampleTest.cs	(revision 11514)
@@ -30,15 +30,7 @@
 
 namespace HeuristicLab.Tests {
-  /// <summary>
-  /// Summary description for TabuSearchVRPSampleTest
-  /// </summary>
   [TestClass]
   public class TabuSearchVRPSampleTest {
-    private const string samplesDirectory = SamplesUtils.Directory;
-    [ClassInitialize]
-    public static void MyClassInitialize(TestContext testContext) {
-      if (!Directory.Exists(samplesDirectory))
-        Directory.CreateDirectory(samplesDirectory);
-    }
+    private const string SampleFileName = "TS_VRP";
 
     [TestMethod]
@@ -47,5 +39,6 @@
     public void CreateTabuSearchVRPSampleTest() {
       var vrp = CreateTabuSearchVrpSample();
-      XmlGenerator.Serialize(vrp, @"Samples\TS_VRP.hl");
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
+      XmlGenerator.Serialize(vrp, path);
     }
     [TestMethod]
Index: trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/VnsTspSampleTest.cs
===================================================================
--- trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/VnsTspSampleTest.cs	(revision 11466)
+++ trunk/sources/HeuristicLab.Tests/HeuristicLab-3.3/Samples/VnsTspSampleTest.cs	(revision 11514)
@@ -31,15 +31,7 @@
 
 namespace HeuristicLab.Tests {
-  /// <summary>
-  /// Summary description for VnsTspSampleTest
-  /// </summary>
   [TestClass]
   public class VnsTspSampleTest {
-    private const string samplesDirectory = SamplesUtils.Directory;
-    [ClassInitialize]
-    public static void MyClassInitialize(TestContext testContext) {
-      if (!Directory.Exists(samplesDirectory))
-        Directory.CreateDirectory(samplesDirectory);
-    }
+    private const string SampleFileName = "VNS_TSP";
 
     [TestMethod]
@@ -48,5 +40,6 @@
     public void CreateVnsTspSampleTest() {
       var vns = CreateVnsTspSample();
-      XmlGenerator.Serialize(vns, @"Samples\VNS_TSP.hl");
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
+      XmlGenerator.Serialize(vns, path);
     }
     [TestMethod]