Index: branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/ClassDiagram.cd
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/ClassDiagram.cd	(revision 11527)
+++ branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/ClassDiagram.cd	(revision 11528)
@@ -1,12 +1,4 @@
 ﻿<?xml version="1.0" encoding="utf-8"?>
 <ClassDiagram MajorVersion="1" MinorVersion="1">
-  <Class Name="HeuristicLab.Core.Networks.Entity" Collapsed="true">
-    <Position X="7.75" Y="0.5" Width="1.5" />
-    <TypeIdentifier>
-      <HashCode>AAAiAACAAAAAQAJAAAAEQQAAAAAAQAAAAAAAAAAEAEQ=</HashCode>
-      <FileName>Core.Networks\Entity.cs</FileName>
-    </TypeIdentifier>
-    <Lollipop Position="0.2" />
-  </Class>
   <Class Name="HeuristicLab.Core.Networks.GenericNode" Collapsed="true">
     <Position X="1" Y="3.5" Width="1.5" />
@@ -63,4 +55,12 @@
     <Lollipop Position="0.2" />
   </Class>
+  <Class Name="HeuristicLab.Core.Networks.NetworkItem" Collapsed="true">
+    <Position X="7.75" Y="0.5" Width="1.5" />
+    <TypeIdentifier>
+      <HashCode>AAAiAACAAAAAQAJAAAAEQQAAAAAAQAAAAAAAAAAEAEQ=</HashCode>
+      <FileName>Core.Networks\NetworkItem.cs</FileName>
+    </TypeIdentifier>
+    <Lollipop Position="0.2" />
+  </Class>
   <Class Name="HeuristicLab.Core.Networks.Node" Collapsed="true">
     <Position X="4.5" Y="2" Width="1.5" />
@@ -170,5 +170,5 @@
   </Class>
   <Interface Name="HeuristicLab.Core.Networks.IConnectedPort" Collapsed="true">
-    <Position X="10" Y="11.75" Width="1.5" />
+    <Position X="7.75" Y="11.75" Width="1.5" />
     <TypeIdentifier>
       <HashCode>AAAAAAAAAAAAAAQAAAAAAAAAACAAAAAAAAAAAAAAAAA=</HashCode>
@@ -176,13 +176,6 @@
     </TypeIdentifier>
   </Interface>
-  <Interface Name="HeuristicLab.Core.Networks.IEntity" Collapsed="true">
-    <Position X="7.75" Y="7.5" Width="1.5" />
-    <TypeIdentifier>
-      <HashCode>AAAAAAAAAAAAAAIAAAAEQAAAAAAAAAAAAAAAAAAAAAQ=</HashCode>
-      <FileName>Core.Networks\IEntity.cs</FileName>
-    </TypeIdentifier>
-  </Interface>
   <Interface Name="HeuristicLab.Core.Networks.IGenericNode" Collapsed="true">
-    <Position X="5.5" Y="10.5" Width="1.5" />
+    <Position X="3.25" Y="10.5" Width="1.5" />
     <TypeIdentifier>
       <HashCode>AAAAAAAAAAAAAAAABAAAAAAAAAAAAAAAAAAAAAAAAAA=</HashCode>
@@ -191,5 +184,5 @@
   </Interface>
   <Interface Name="HeuristicLab.Core.Networks.IGenericPort" Collapsed="true">
-    <Position X="13.5" Y="11.75" Width="1.5" />
+    <Position X="11.25" Y="11.75" Width="1.5" />
     <TypeIdentifier>
       <HashCode>ARAAMAAAQAAAACABACAAAAAAAgQAAAAAAAAACQAAAAQ=</HashCode>
@@ -219,5 +212,5 @@
   </Interface>
   <Interface Name="HeuristicLab.Core.Networks.INetwork" Collapsed="true">
-    <Position X="3.25" Y="10.5" Width="1.5" />
+    <Position X="1" Y="10.5" Width="1.5" />
     <TypeIdentifier>
       <HashCode>AAAgAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA=</HashCode>
@@ -225,6 +218,13 @@
     </TypeIdentifier>
   </Interface>
+  <Interface Name="HeuristicLab.Core.Networks.INetworkItem" Collapsed="true">
+    <Position X="7.75" Y="7.5" Width="1.5" />
+    <TypeIdentifier>
+      <HashCode>AAAAAAAAAAAAAAIAAAAEQAAAAAAAAAAAAAAAAAAAAAQ=</HashCode>
+      <FileName>Core.Networks\INetworkItem.cs</FileName>
+    </TypeIdentifier>
+  </Interface>
   <Interface Name="HeuristicLab.Core.Networks.INode" Collapsed="true">
-    <Position X="5.5" Y="9" Width="1.5" />
+    <Position X="3.25" Y="9" Width="1.5" />
     <TypeIdentifier>
       <HashCode>AAAAAAAAAAAAAAAABAAAQAAAAAAAAAAAAAAAAAAAAAA=</HashCode>
@@ -233,5 +233,5 @@
   </Interface>
   <Interface Name="HeuristicLab.Core.Networks.IParameterizedPort" Collapsed="true">
-    <Position X="12.25" Y="10.5" Width="1.5" />
+    <Position X="10" Y="10.5" Width="1.5" />
     <TypeIdentifier>
       <HashCode>AAQAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAIAAAAAAAAA=</HashCode>
@@ -240,5 +240,5 @@
   </Interface>
   <Interface Name="HeuristicLab.Core.Networks.IPort" Collapsed="true">
-    <Position X="12.25" Y="9" Width="1.5" />
+    <Position X="10" Y="9" Width="1.5" />
     <TypeIdentifier>
       <HashCode>AAAAAAAAAAAAAAAAAAAAQAAAAAAAAAAAAAAAAAAAAAA=</HashCode>
@@ -247,5 +247,5 @@
   </Interface>
   <Interface Name="HeuristicLab.Core.Networks.IPortParameter" Collapsed="true">
-    <Position X="1" Y="9" Width="1.5" />
+    <Position X="14.5" Y="9" Width="1.5" />
     <TypeIdentifier>
       <HashCode>AAAAAAAAAAIAQAAAAAAAQAAAAADAAAAAEQAAAAAAAAA=</HashCode>
@@ -254,5 +254,5 @@
   </Interface>
   <Interface Name="HeuristicLab.Core.Networks.IPortParameter&lt;T&gt;" Collapsed="true">
-    <Position X="1" Y="10.5" Width="1.5" />
+    <Position X="14.5" Y="10.5" Width="1.5" />
     <TypeIdentifier>
       <HashCode>AAAAAAAAAAAAAAAAAAAAAAAAAABAAAAAEAAAAAAAAAA=</HashCode>
@@ -268,5 +268,5 @@
   </Interface>
   <Interface Name="HeuristicLab.Optimization.Networks.IAlgorithmNode" Collapsed="true">
-    <Position X="7.75" Y="10.5" Width="1.5" />
+    <Position X="5.5" Y="10.5" Width="1.5" />
     <TypeIdentifier>
       <HashCode>AAAAAAAAAAAAEAAABAAAQAAAAAAAAAAAAAAAAAQAAAA=</HashCode>
@@ -275,5 +275,5 @@
   </Interface>
   <Interface Name="HeuristicLab.Optimization.Networks.IConfigurationPort" Collapsed="true">
-    <Position X="12.25" Y="13.25" Width="1.5" />
+    <Position X="10" Y="13.25" Width="1.5" />
     <TypeIdentifier>
       <HashCode>AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA=</HashCode>
@@ -282,5 +282,5 @@
   </Interface>
   <Interface Name="HeuristicLab.Optimization.Networks.IExecutionPort" Collapsed="true">
-    <Position X="14.5" Y="13.25" Width="1.5" />
+    <Position X="12.25" Y="13.25" Width="1.5" />
     <TypeIdentifier>
       <HashCode>AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA=</HashCode>
Index: branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/Entity.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/Entity.cs	(revision 11527)
+++ 	(revision )
@@ -1,97 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using HeuristicLab.Common;
-using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using System;
-using System.Collections.Generic;
-using System.Drawing;
-using System.Linq;
-
-namespace HeuristicLab.Core.Networks {
-  [Item("Entity", "Abstract base class for entities of an optimization network.")]
-  [StorableClass]
-  public abstract class Entity : NamedItem, IEntity {
-    public static readonly string PathSeparator = " => ";
-    public static new Image StaticItemImage {
-      get { return HeuristicLab.Common.Resources.VSImageLibrary.Class; }
-    }
-
-    private IEntity parent;
-    public IEntity Parent {
-      get { return parent; }
-      protected set {
-        if (value != parent) {
-          DeregisterParentEvents();
-          parent = value;
-          RegisterParentEvents();
-          OnPathChanged();
-        }
-      }
-    }
-    public virtual IEnumerable<IEntity> Children {
-      get { return Enumerable.Empty<IEntity>(); }
-    }
-    public string Path {
-      get {
-        return parent != null ? parent.Path + PathSeparator + Name : Name;
-      }
-    }
-
-    [StorableConstructor]
-    protected Entity(bool deserializing) : base(deserializing) { }
-    protected Entity(Entity original, Cloner cloner) : base(original, cloner) { }
-    protected Entity() : base("Entity") { }
-    protected Entity(string name) : base(name) { }
-    protected Entity(string name, string description) : base(name, description) { }
-
-    protected override void OnNameChanging(CancelEventArgs<string> e) {
-      base.OnNameChanging(e);
-      e.Cancel = e.Cancel || e.Value.Contains(PathSeparator);
-    }
-    protected override void OnNameChanged() {
-      base.OnNameChanged();
-      OnPathChanged();
-    }
-
-    public event EventHandler PathChanged;
-    protected virtual void OnPathChanged() {
-      var handler = PathChanged;
-      if (handler != null) handler(this, EventArgs.Empty);
-    }
-
-    #region Parent Events
-    protected virtual void RegisterParentEvents() {
-      if (parent != null) {
-        parent.PathChanged += Parent_PathChanged;
-      }
-    }
-    protected virtual void DeregisterParentEvents() {
-      if (parent != null) {
-        parent.PathChanged -= Parent_PathChanged;
-      }
-    }
-    void Parent_PathChanged(object sender, EventArgs e) {
-      OnPathChanged();
-    }
-    #endregion
-  }
-}
Index: branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/GenericPort.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/GenericPort.cs	(revision 11527)
+++ branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/GenericPort.cs	(revision 11528)
@@ -161,7 +161,7 @@
       // collect output parameters from local port
       message.Values.AddRange(
-        Parameters.
-        Where(p => p.Type.HasFlag(PortParameterType.Output)).
-        Select(p => p.CreateMessageValue())
+        Parameters
+          .Where(p => p.Type.HasFlag(PortParameterType.Output))
+          .Select(p => p.CreateMessageValue())
       );
 
@@ -169,7 +169,7 @@
       if (ConnectedPort != null) {
         message.Values.AddRange(
-          ConnectedPort.Parameters.
-          Where(p => p.Type.HasFlag(PortParameterType.Input) && !message.Values.ContainsKey(p.Name)).
-          Select(p => p.CreateMessageValue())
+          ConnectedPort.Parameters
+            .Where(p => p.Type.HasFlag(PortParameterType.Input) && !message.Values.ContainsKey(p.Name))
+            .Select(p => p.CreateMessageValue())
         );
       }
@@ -178,7 +178,7 @@
       if (ConnectedPort != null) {
         message.Values.AddRange(
-          ConnectedPort.Parameters.
-          Where(p => p.Type.HasFlag(PortParameterType.Output) && !message.Values.ContainsKey(p.Name)).
-          Select(p => p.CreateMessageValue())
+          ConnectedPort.Parameters
+            .Where(p => p.Type.HasFlag(PortParameterType.Output) && !message.Values.ContainsKey(p.Name))
+            .Select(p => p.CreateMessageValue())
         );
       }
@@ -186,7 +186,7 @@
       // collect remaining input parameters from local port
       message.Values.AddRange(
-        Parameters.
-        Where(p => p.Type.HasFlag(PortParameterType.Input) && !message.Values.ContainsKey(p.Name)).
-        Select(p => p.CreateMessageValue())
+        Parameters
+          .Where(p => p.Type.HasFlag(PortParameterType.Input) && !message.Values.ContainsKey(p.Name))
+          .Select(p => p.CreateMessageValue())
       );
 
Index: branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/IEntity.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/IEntity.cs	(revision 11527)
+++ 	(revision )
@@ -1,32 +1,0 @@
-#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-
-namespace HeuristicLab.Core.Networks {
-  public interface IEntity : INamedItem {
-    IEntity Parent { get; }
-    IEnumerable<IEntity> Children { get; }
-    string Path { get; }
-    event EventHandler PathChanged;
-  }
-}
Index: branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/INetworkItem.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/INetworkItem.cs	(revision 11528)
+++ branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/INetworkItem.cs	(revision 11528)
@@ -0,0 +1,32 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+
+namespace HeuristicLab.Core.Networks {
+  public interface INetworkItem : INamedItem {
+    INetworkItem Parent { get; }
+    IEnumerable<INetworkItem> Children { get; }
+    string Path { get; }
+    event EventHandler PathChanged;
+  }
+}
Index: branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/INode.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/INode.cs	(revision 11527)
+++ branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/INode.cs	(revision 11528)
@@ -21,5 +21,5 @@
 
 namespace HeuristicLab.Core.Networks {
-  public interface INode : IEntity {
+  public interface INode : INetworkItem {
     new INetwork Parent { get; set; }
     IKeyedItemCollection<string, IPort> Ports { get; }
Index: branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/IPort.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/IPort.cs	(revision 11527)
+++ branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/IPort.cs	(revision 11528)
@@ -21,5 +21,5 @@
 
 namespace HeuristicLab.Core.Networks {
-  public interface IPort : IEntity {
+  public interface IPort : INetworkItem {
     new INode Parent { get; set; }
   }
Index: branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/IPortParameter.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/IPortParameter.cs	(revision 11527)
+++ branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/IPortParameter.cs	(revision 11528)
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.Core.Networks {
-  public interface IPortParameter : IEntity {
+  public interface IPortParameter : INetworkItem {
     new IPort Parent { get; set; }
     Type DataType { get; }
Index: branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/Network.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/Network.cs	(revision 11527)
+++ branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/Network.cs	(revision 11528)
@@ -37,6 +37,6 @@
     }
 
-    public override IEnumerable<IEntity> Children {
-      get { return base.Children.Concat(Nodes.AsEnumerable<IEntity>()); }
+    public override IEnumerable<INetworkItem> Children {
+      get { return base.Children.Concat(Nodes.AsEnumerable<INetworkItem>()); }
     }
 
Index: branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/NetworkItem.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/NetworkItem.cs	(revision 11528)
+++ branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/NetworkItem.cs	(revision 11528)
@@ -0,0 +1,97 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using System;
+using System.Collections.Generic;
+using System.Drawing;
+using System.Linq;
+
+namespace HeuristicLab.Core.Networks {
+  [Item("NetworkItem", "Abstract base class for items of a network.")]
+  [StorableClass]
+  public abstract class NetworkItem : NamedItem, INetworkItem {
+    public static readonly string PathSeparator = " => ";
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Class; }
+    }
+
+    private INetworkItem parent;
+    public INetworkItem Parent {
+      get { return parent; }
+      protected set {
+        if (value != parent) {
+          DeregisterParentEvents();
+          parent = value;
+          RegisterParentEvents();
+          OnPathChanged();
+        }
+      }
+    }
+    public virtual IEnumerable<INetworkItem> Children {
+      get { return Enumerable.Empty<INetworkItem>(); }
+    }
+    public string Path {
+      get {
+        return parent != null ? parent.Path + PathSeparator + Name : Name;
+      }
+    }
+
+    [StorableConstructor]
+    protected NetworkItem(bool deserializing) : base(deserializing) { }
+    protected NetworkItem(NetworkItem original, Cloner cloner) : base(original, cloner) { }
+    protected NetworkItem() : base("NetworkItem") { }
+    protected NetworkItem(string name) : base(name) { }
+    protected NetworkItem(string name, string description) : base(name, description) { }
+
+    protected override void OnNameChanging(CancelEventArgs<string> e) {
+      base.OnNameChanging(e);
+      e.Cancel = e.Cancel || e.Value.Contains(PathSeparator);
+    }
+    protected override void OnNameChanged() {
+      base.OnNameChanged();
+      OnPathChanged();
+    }
+
+    public event EventHandler PathChanged;
+    protected virtual void OnPathChanged() {
+      var handler = PathChanged;
+      if (handler != null) handler(this, EventArgs.Empty);
+    }
+
+    #region Parent Events
+    protected virtual void RegisterParentEvents() {
+      if (parent != null) {
+        parent.PathChanged += Parent_PathChanged;
+      }
+    }
+    protected virtual void DeregisterParentEvents() {
+      if (parent != null) {
+        parent.PathChanged -= Parent_PathChanged;
+      }
+    }
+    void Parent_PathChanged(object sender, EventArgs e) {
+      OnPathChanged();
+    }
+    #endregion
+  }
+}
Index: branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/Node.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/Node.cs	(revision 11527)
+++ branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/Node.cs	(revision 11528)
@@ -29,5 +29,5 @@
   [Item("Node", "A node of an optimization network.")]
   [StorableClass]
-  public class Node : Entity, INode {
+  public class Node : NetworkItem, INode {
     public static new Image StaticItemImage {
       get { return HeuristicLab.Common.Resources.VSImageLibrary.RadialChart; }
@@ -41,6 +41,6 @@
       }
     }
-    public override IEnumerable<IEntity> Children {
-      get { return base.Children.Concat(Ports.AsEnumerable<IEntity>()); }
+    public override IEnumerable<INetworkItem> Children {
+      get { return base.Children.Concat(Ports.AsEnumerable<INetworkItem>()); }
     }
 
Index: branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/ParameterizedPort.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/ParameterizedPort.cs	(revision 11527)
+++ branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/ParameterizedPort.cs	(revision 11528)
@@ -30,6 +30,6 @@
   [StorableClass]
   public abstract class ParameterizedPort : Port, IParameterizedPort {
-    public override IEnumerable<IEntity> Children {
-      get { return base.Children.Concat(Parameters.AsEnumerable<IEntity>()); }
+    public override IEnumerable<INetworkItem> Children {
+      get { return base.Children.Concat(Parameters.AsEnumerable<INetworkItem>()); }
     }
 
Index: branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/Port.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/Port.cs	(revision 11527)
+++ branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/Port.cs	(revision 11528)
@@ -27,5 +27,5 @@
   [Item("Port", "Abstract base class for ports of an optimization network node.")]
   [StorableClass]
-  public abstract class Port : Entity, IPort {
+  public abstract class Port : NetworkItem, IPort {
     public static new Image StaticItemImage {
       get { return HeuristicLab.Common.Resources.VSImageLibrary.Field; }
Index: branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/PortParameter.cs
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/PortParameter.cs	(revision 11527)
+++ branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/Core.Networks/PortParameter.cs	(revision 11528)
@@ -28,5 +28,5 @@
   [Item("PortParameter", "A parameter of a port.")]
   [StorableClass]
-  public class PortParameter<T> : Entity, IPortParameter<T> where T : class, IItem {
+  public class PortParameter<T> : NetworkItem, IPortParameter<T> where T : class, IItem {
     public static new Image StaticItemImage {
       get { return HeuristicLab.Common.Resources.VSImageLibrary.Field; }
Index: branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/HeuristicLab.Optimization.Networks-3.3.csproj
===================================================================
--- branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/HeuristicLab.Optimization.Networks-3.3.csproj	(revision 11527)
+++ branches/OptimizationNetworks/HeuristicLab.Optimization.Networks/3.3/HeuristicLab.Optimization.Networks-3.3.csproj	(revision 11528)
@@ -90,9 +90,7 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="Core.Networks\Entity.cs" />
     <Compile Include="Core.Networks\GenericNode.cs" />
     <Compile Include="Core.Networks\GenericPort.cs" />
     <Compile Include="Core.Networks\IConnectedPort.cs" />
-    <Compile Include="Core.Networks\IEntity.cs" />
     <Compile Include="Core.Networks\IGenericNode.cs" />
     <Compile Include="Core.Networks\IGenericPort.cs" />
@@ -100,4 +98,5 @@
     <Compile Include="Core.Networks\IMessageValue.cs" />
     <Compile Include="Core.Networks\INetwork.cs" />
+    <Compile Include="Core.Networks\INetworkItem.cs" />
     <Compile Include="Core.Networks\INode.cs" />
     <Compile Include="Core.Networks\IParameterizedPort.cs" />
@@ -109,4 +108,5 @@
     <Compile Include="Core.Networks\MessageValueCollection.cs" />
     <Compile Include="Core.Networks\Network.cs" />
+    <Compile Include="Core.Networks\NetworkItem.cs" />
     <Compile Include="Core.Networks\Node.cs" />
     <Compile Include="Core.Networks\NodeCollection.cs" />